import type { SolAmount } from './Amount';
import type { PublicKey } from './PublicKey';
export type AccountHeader = {
    executable: boolean;
    owner: PublicKey;
    lamports: SolAmount;
    rentEpoch?: number;
};
export type RpcAccount = AccountHeader & {
    publicKey: PublicKey;
    data: Uint8Array;
};
export type MaybeRpcAccount = ({
    exists: true;
} & RpcAccount) | {
    exists: false;
    address: PublicKey;
};
export type Account<T extends object> = T & {
    address: PublicKey;
    header: AccountHeader;
};
export type MaybeAccount<T extends object> = ({
    exists: true;
} & Account<T>) | {
    exists: false;
    address: PublicKey;
};
export declare function assertAccountExists<T extends object, A extends MaybeAccount<T> | MaybeRpcAccount>(account: A, name?: string, solution?: string): asserts account is A & {
    exists: true;
};
